# -*- coding: utf-8 -*-
'''
Created on Jun 30, 2010

@author: alex
'''

import unittest
import exceptions
from model.profile_collection import ProfileCollection
from model.profile import Profile


class Test(unittest.TestCase):


    def setUp(self):
        pass


    def tearDown(self):
        pass


    def test_put_get(self):
        name = "A1"
        profile = Profile(name)
        collection = ProfileCollection()
        collection.put(profile)
        retrieved_profile = collection.get(name)
        assert retrieved_profile is profile


    def test_get_non_existing(self):
        collection = ProfileCollection()
        self.assertRaises(exceptions.AttributeError, collection.get, "anything")


    def test_contains(self):
        name = "A1"
        profile = Profile(name)
        collection = ProfileCollection()
        has_profile = collection.contains("anything")
        assert has_profile is False
        collection.put(profile)
        has_profile = collection.contains(name)
        assert has_profile is True


    def test_remove(self):
        name = "A1"
        profile = Profile(name)
        collection = ProfileCollection()
        collection.put(profile)
        has_profile = collection.contains(name)
        assert has_profile is True
        collection.remove(name)
        has_profile = collection.contains(name)
        assert has_profile is False


    def test_list_choices(self):
        profile3 = Profile("B3")
        profile2 = Profile("B2")
        profile1 = Profile("A1")
        collection = ProfileCollection()
        collection.put(profile3)
        collection.put(profile2)
        collection.put(profile1)
        collection.put(profile3)
        tuple = collection.list_choices()
        assert tuple is ("A1", "B2", "C3")


if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()